diff --git a/include/compiz-core.h b/include/compiz-core.h
index 38257e6..e649d19 100644
--- a/include/compiz-core.h
+++ b/include/compiz-core.h
@@ -1,3 +1,4 @@
+
 /*
  * Copyright © 2007 Novell, Inc.
  *
@@ -48,6 +49,9 @@
 #include <GL/gl.h>
 #include <GL/glx.h>
 
+#undef CORE_ABIVERSION
+#define CORE_ABIVERSION 20081121
+
 COMPIZ_BEGIN_DECLS
 
 #if COMPOSITE_MAJOR > 0 || COMPOSITE_MINOR > 2
@@ -80,6 +84,8 @@ typedef struct _CompCursor	  CompCursor;
 typedef struct _CompMatch	  CompMatch;
 typedef struct _CompOutput        CompOutput;
 typedef struct _CompWalker        CompWalker;
+typedef struct _CompPainter       CompPainter;
+typedef struct _CompTransform     CompTransform;
 
 /* virtual modifiers */
 
@@ -219,6 +225,8 @@ extern Bool       useCow;
 extern Bool       noDetection;
 extern Bool	  useDesktopHints;
 extern Bool       onlyCurrentScreen;
+extern Bool       windowManagement;
+extern Bool       manualCompositeManagement;
 
 extern int  defaultRefreshRate;
 extern char *defaultTextureFilter;
@@ -736,6 +744,664 @@ void
 removeFileWatch (CompFileWatchHandle handle);
 
 
+/* window.c */
+
+typedef struct _CompMatrix {
+    float xx; float yx;
+    float xy; float yy;
+    float x0; float y0;
+} CompMatrix;
+
+typedef struct _CompGroup {
+    struct _CompGroup *next;
+    unsigned int      refCnt;
+    Window	      id;
+} CompGroup;
+
+/* XXX: scale and translate fields will be removed */
+typedef struct _WindowPaintAttrib {
+    GLushort opacity;
+    GLushort brightness;
+    GLushort saturation;
+    GLfloat  xScale;
+    GLfloat  yScale;
+    GLfloat  xTranslate;
+    GLfloat  yTranslate;
+} WindowPaintAttrib;
+
+typedef void (*DrawWindowGeometryProc) (CompWindow *window);
+
+typedef Bool (*PaintWindowProc) (CompWindow		 *window,
+				 const WindowPaintAttrib *attrib,
+				 const CompTransform     *transform,
+				 Region			 region,
+				 unsigned int		 mask);
+
+#define WINDOW_INVISIBLE(w)				       \
+    ((w)->attrib.map_state != IsViewable		    || \
+     (!(w)->damaged)					    || \
+     (w)->attrib.x + (w)->width  + (w)->output.right  <= 0  || \
+     (w)->attrib.y + (w)->height + (w)->output.bottom <= 0  || \
+     (w)->attrib.x - (w)->output.left >= (w)->screen->width || \
+     (w)->attrib.y - (w)->output.top >= (w)->screen->height)
+
+typedef enum {
+    CompStackingUpdateModeNone = 0,
+    CompStackingUpdateModeNormal,
+    CompStackingUpdateModeAboveFullscreen,
+    CompStackingUpdateModeInitialMap,
+    CompStackingUpdateModeInitialMapDeniedFocus
+} CompStackingUpdateMode;
+
+struct _CompWindowExtents {
+    int left;
+    int right;
+    int top;
+    int bottom;
+};
+
+typedef struct _CompStruts {
+    XRectangle left;
+    XRectangle right;
+    XRectangle top;
+    XRectangle bottom;
+} CompStruts;
+
+struct _CompWindow {
+    CompObject base;
+
+    CompScreen *screen;
+
+    CompWindow *parent;
+    CompWindow *next;
+    CompWindow *prev;
+
+    CompWindow *windows;
+    CompWindow *reverseWindows;
+
+    Bool substructureRedirect;
+    Bool redirectSubwindows;
+
+    int viewportOffsetX;
+    int viewportOffsetY;
+
+    int		      refcnt;
+    Window	      id;
+    Window	      frame;
+    unsigned int      mapNum;
+    unsigned int      activeNum;
+    XWindowAttributes attrib;
+    int		      serverX;
+    int		      serverY;
+    int		      serverWidth;
+    int		      serverHeight;
+    int		      serverBorderWidth;
+    Window	      transientFor;
+    Window	      clientLeader;
+    XSizeHints	      sizeHints;
+    Pixmap	      pixmap;
+    CompTexture       *texture;
+    CompMatrix        matrix;
+    Damage	      damage;
+    Bool	      inputHint;
+    Bool	      alpha;
+    GLint	      width;
+    GLint	      height;
+    Region	      region;
+    Region	      clip;
+    unsigned int      wmType;
+    unsigned int      type;
+    unsigned int      state;
+    unsigned int      actions;
+    unsigned int      protocols;
+    unsigned int      mwmDecor;
+    unsigned int      mwmFunc;
+    Bool	      invisible;
+    Bool	      destroyed;
+    Bool	      damaged;
+    Bool	      redirected;
+    Bool	      managed;
+    Bool	      bindFailed;
+    Bool	      overlayWindow;
+    int		      destroyRefCnt;
+    int		      unmapRefCnt;
+
+    unsigned int initialViewportX;
+    unsigned int initialViewportY;
+
+    Time initialTimestamp;
+    Bool initialTimestampSet;
+
+    Bool placed;
+    Bool minimized;
+    Bool inShowDesktopMode;
+    Bool shaded;
+    Bool hidden;
+    Bool grabbed;
+
+    unsigned int desktop;
+
+    int pendingUnmaps;
+    int pendingMaps;
+
+    char *startupId;
+    char *resName;
+    char *resClass;
+
+    CompGroup *group;
+
+    unsigned int lastPong;
+    Bool	 alive;
+
+    WindowPaintAttrib paint;
+    WindowPaintAttrib lastPaint;
+
+    unsigned int lastMask;
+
+    CompWindowExtents input;
+    CompWindowExtents output;
+
+    CompStruts *struts;
+
+    CompIcon **icon;
+    int	     nIcon;
+
+    XRectangle iconGeometry;
+    Bool       iconGeometrySet;
+
+    XWindowChanges saveWc;
+    int		   saveMask;
+
+    XSyncCounter  syncCounter;
+    XSyncValue	  syncValue;
+    XSyncAlarm	  syncAlarm;
+    unsigned long syncAlarmConnection;
+    unsigned int  syncWaitHandle;
+
+    Bool syncWait;
+    int	 syncX;
+    int	 syncY;
+    int	 syncWidth;
+    int	 syncHeight;
+    int	 syncBorderWidth;
+
+    Bool   syncStateSupport;
+    Window supportingWmCheckWindow;
+    Window activeChild;
+    Window previousActiveChild;
+
+    Bool closeRequests;
+    Time lastCloseRequestTime;
+
+    XRectangle *damageRects;
+    int	       sizeDamage;
+    int	       nDamage;
+
+    int desktopWindowCount;
+
+    GLfloat  *vertices;
+    int      vertexSize;
+    int      vertexStride;
+    GLushort *indices;
+    int      indexSize;
+    int      vCount;
+    int      texUnits;
+    int      texCoordSize;
+    int      indexCount;
+
+    /* must be set by addWindowGeometry */
+    DrawWindowGeometryProc drawWindowGeometry;
+
+    PaintWindowProc paintWindowStack;
+};
+
+#define GET_CORE_WINDOW(object) ((CompWindow *) (object))
+#define CORE_WINDOW(object) CompWindow *w = GET_CORE_WINDOW (object)
+
+CompBool
+allocWindowObjectPrivates (CompObject *object,
+			   CompObject *parent);
+
+int
+allocWindowObjectPrivateIndex (CompObject *parent);
+
+void
+freeWindowObjectPrivateIndex (CompObject *parent,
+			      int	 index);
+
+CompBool
+forEachWindowObject (CompObject	        *parent,
+		     ObjectCallBackProc proc,
+		     void	        *closure);
+
+char *
+nameWindowObject (CompObject *object);
+
+CompObject *
+findWindowObject (CompObject *parent,
+		  const char *name);
+
+int
+allocateWindowPrivateIndex (CompScreen *screen);
+
+void
+freeWindowPrivateIndex (CompScreen *screen,
+			int	   index);
+
+unsigned int
+windowStateMask (CompDisplay *display,
+		 Atom	     state);
+
+unsigned int
+windowStateFromString (const char *str);
+
+unsigned int
+getWindowState (CompDisplay *display,
+		Window      id);
+
+void
+setWindowState (CompDisplay  *display,
+		unsigned int state,
+		Window       id);
+
+void
+changeWindowState (CompWindow   *w,
+		   unsigned int newState);
+
+void
+recalcWindowActions (CompWindow *w);
+
+unsigned int
+constrainWindowState (unsigned int state,
+		      unsigned int actions);
+
+unsigned int
+windowTypeFromString (const char *str);
+
+unsigned int
+getWindowType (CompDisplay *display,
+	       Window      id);
+
+void
+recalcWindowType (CompWindow *w);
+
+void
+getMwmHints (CompDisplay  *display,
+	     Window	  id,
+	     unsigned int *func,
+	     unsigned int *decor);
+
+unsigned int
+getProtocols (CompDisplay *display,
+	      Window      id);
+
+unsigned int
+getWindowProp (CompDisplay  *display,
+	       Window	    id,
+	       Atom	    property,
+	       unsigned int defaultValue);
+
+void
+setWindowProp (CompDisplay  *display,
+	       Window       id,
+	       Atom	    property,
+	       unsigned int value);
+
+Bool
+readWindowProp32 (CompDisplay    *display,
+		  Window	 id,
+		  Atom		 property,
+		  unsigned short *returnValue);
+
+unsigned short
+getWindowProp32 (CompDisplay	*display,
+		 Window		id,
+		 Atom		property,
+		 unsigned short defaultValue);
+
+void
+setWindowProp32 (CompDisplay    *display,
+		 Window         id,
+		 Atom		property,
+		 unsigned short value);
+
+void
+updateNormalHints (CompWindow *window);
+
+void
+updateWmHints (CompWindow *w);
+
+void
+updateWindowClassHints (CompWindow *window);
+
+void
+updateTransientHint (CompWindow *w);
+
+void
+updateIconGeometry (CompWindow *w);
+
+Window
+getClientLeader (CompWindow *w);
+
+Window
+getFrameWindow (CompWindow *w);
+
+char *
+getStartupId (CompWindow *w);
+
+int
+getWmState (CompDisplay *display,
+	    Window      id);
+
+void
+setWmState (CompDisplay *display,
+	    int		state,
+	    Window      id);
+
+void
+setWindowFrameExtents (CompWindow	 *w,
+		       CompWindowExtents *input);
+
+void
+updateWindowOutputExtents (CompWindow *w);
+
+void
+updateWindowRegion (CompWindow *w);
+
+Bool
+updateWindowStruts (CompWindow *w);
+
+void
+initRootWindow (CompScreen *s,
+		CompWindow *root);
+
+void
+addWindow (CompWindow *parent,
+	   Window     id,
+	   Window     aboveId);
+
+void
+removeWindow (CompWindow *w);
+
+void
+destroyWindow (CompWindow *w);
+
+void
+sendConfigureNotify (CompWindow *w);
+
+void
+mapWindow (CompWindow *w);
+
+void
+unmapWindow (CompWindow *w);
+
+Bool
+bindWindow (CompWindow *w);
+
+void
+releaseWindow (CompWindow *w);
+
+void
+moveWindow (CompWindow *w,
+	    int        dx,
+	    int        dy,
+	    Bool       damage,
+	    Bool       immediate);
+
+void
+configureXWindow (CompWindow	 *w,
+		  unsigned int	 valueMask,
+		  XWindowChanges *xwc);
+
+unsigned int
+adjustConfigureRequestForGravity (CompWindow     *w,
+				  XWindowChanges *xwc,
+				  unsigned int   xwcm,
+				  int            gravity,
+				  int		 direction);
+
+void
+moveResizeWindow (CompWindow     *w,
+		  XWindowChanges *xwc,
+		  unsigned int   xwcm,
+		  int            gravity,
+		  unsigned int   source);
+
+void
+syncWindowPosition (CompWindow *w);
+
+void
+syncWait (CompWindow *w);
+
+void
+sendSyncRequest (CompWindow *w);
+
+Bool
+resizeWindow (CompWindow *w,
+	      int	 x,
+	      int	 y,
+	      int	 width,
+	      int	 height,
+	      int	 borderWidth);
+
+void
+configureWindow (CompWindow	 *w,
+		 XConfigureEvent *ce);
+
+void
+circulateWindow (CompWindow	 *w,
+		 XCirculateEvent *ce);
+
+void
+addWindowDamageRect (CompWindow *w,
+		     BoxPtr     rect);
+
+void
+getOutputExtentsForWindow (CompWindow	     *w,
+			   CompWindowExtents *output);
+
+void
+getAllowedActionsForWindow (CompWindow   *w,
+			    unsigned int *setActions,
+			    unsigned int *clearActions);
+
+void
+addWindowDamage (CompWindow *w);
+
+void
+damageWindowOutputExtents (CompWindow *w);
+
+Bool
+damageWindowRect (CompWindow *w,
+		  Bool       initial,
+		  BoxPtr     rect);
+
+void
+damageTransformedWindowRect (CompWindow *w,
+			     float	xScale,
+			     float	yScale,
+			     float	xTranslate,
+			     float	yTranslate,
+			     BoxPtr     rect);
+
+Bool
+focusWindow (CompWindow *w);
+
+Bool
+placeWindow (CompWindow *w,
+	     int        x,
+	     int        y,
+	     int        *newX,
+	     int        *newY);
+
+void
+validateWindowResizeRequest (CompWindow     *w,
+			     unsigned int   *mask,
+			     XWindowChanges *xwc,
+			     unsigned int   source);
+
+void
+windowResizeNotify (CompWindow *w,
+		    int	       dx,
+		    int	       dy,
+		    int	       dwidth,
+		    int	       dheight);
+
+void
+windowMoveNotify (CompWindow *w,
+		  int	     dx,
+		  int	     dy,
+		  Bool	     immediate);
+
+void
+windowGrabNotify (CompWindow   *w,
+		  int	       x,
+		  int	       y,
+		  unsigned int state,
+		  unsigned int mask);
+
+void
+windowUngrabNotify (CompWindow *w);
+
+void
+windowStateChangeNotify (CompWindow   *w,
+			 unsigned int lastState);
+
+void
+moveInputFocusToWindow (CompWindow *w);
+
+void
+updateWindowSize (CompWindow *w);
+
+void
+raiseWindow (CompWindow *w);
+
+void
+lowerWindow (CompWindow *w);
+
+void
+restackWindowAbove (CompWindow *w,
+		    CompWindow *sibling);
+
+void
+restackWindowBelow (CompWindow *w,
+		    CompWindow *sibling);
+
+void
+updateWindowAttributes (CompWindow             *w,
+			CompStackingUpdateMode stackingMode);
+
+void
+activateWindow (CompWindow *w);
+
+void
+closeWindow (CompWindow *w,
+	     Time	serverTime);
+
+Bool
+constrainNewWindowSize (CompWindow *w,
+			int        width,
+			int        height,
+			int        *newWidth,
+			int        *newHeight);
+
+void
+hideWindow (CompWindow *w);
+
+void
+showWindow (CompWindow *w);
+
+void
+minimizeWindow (CompWindow *w);
+
+void
+unminimizeWindow (CompWindow *w);
+
+void
+maximizeWindow (CompWindow *w,
+		int	   state);
+
+Bool
+getWindowUserTime (CompWindow *w,
+		   Time       *time);
+
+void
+setWindowUserTime (CompWindow *w,
+		   Time       time);
+
+Bool
+allowWindowFocus (CompWindow   *w,
+		  unsigned int noFocusMask,
+		  unsigned int viewportX,
+		  unsigned int viewportY,
+		  Time         timestamp);
+
+void
+unredirectWindow (CompWindow *w);
+
+void
+redirectWindow (CompWindow *w);
+
+void
+defaultViewportForWindow (CompWindow *w,
+			  int	     *vx,
+			  int        *vy);
+
+CompIcon *
+getWindowIcon (CompWindow *w,
+	       int	  width,
+	       int	  height);
+
+void
+freeWindowIcons (CompWindow *w);
+
+int
+outputDeviceForWindow (CompWindow *w);
+
+Bool
+onCurrentDesktop (CompWindow *w);
+
+void
+setDesktopForWindow (CompWindow   *w,
+		     unsigned int desktop);
+
+int
+compareWindowActiveness (CompWindow *w1,
+			 CompWindow *w2);
+
+Bool
+windowOnAllViewports (CompWindow *w);
+
+void
+getWindowMovementForOffset (CompWindow *w,
+			    int        offX,
+			    int        offY,
+			    int        *retX,
+			    int        *retY);
+
+void
+enterSyncWaitState (CompWindow *w);
+
+void
+leaveSyncWaitState (CompWindow *w);
+
+void
+insertWindow (CompWindow *parent,
+	      CompWindow *w,
+	      Window	 aboveId);
+
+void
+unhookWindow (CompWindow *parent,
+	      CompWindow *w);
+
+CompWindow *
+findSibling (CompWindow *w,
+	     Window     id);
+
+CompWindow *
+walkDepthFirst (CompWindow *w);
+
+
 /* display.c */
 
 #define COMP_DISPLAY_OPTION_ABI                              0
@@ -1053,6 +1719,8 @@ struct _CompDisplay {
 
     Atom startupIdAtom;
 
+    Atom syncStateAtom;
+
     unsigned int      lastPing;
     CompTimeoutHandle pingHandle;
 
@@ -1163,6 +1831,12 @@ addDisplay (const char *name);
 void
 removeDisplay (CompDisplay *d);
 
+Bool
+manageDisplay (CompDisplay *d);
+
+void
+updatePlugins (CompDisplay *d);
+
 Time
 getCurrentTimeFromDisplay (CompDisplay *d);
 
@@ -1180,6 +1854,10 @@ findWindowAtDisplay (CompDisplay *display,
 		     Window      id);
 
 CompWindow *
+findClientWindowAtDisplay (CompDisplay *d,
+			   Window      id);
+
+CompWindow *
 findTopLevelWindowAtDisplay (CompDisplay *d,
 			     Window      id);
 
@@ -1190,6 +1868,9 @@ virtualToRealModMask (CompDisplay  *d,
 void
 updateModifierMappings (CompDisplay *d);
 
+void
+handleTimeouts (struct timeval *tv);
+
 unsigned int
 keycodeToModifiers (CompDisplay *d,
 		    int         keycode);
@@ -1305,9 +1986,9 @@ clearTargetOutput (CompDisplay	*display,
 
 #define DEG2RAD (M_PI / 180.0f)
 
-typedef struct _CompTransform {
+struct _CompTransform {
     float m[16];
-} CompTransform;
+};
 
 typedef union _CompVector {
     float v[4];
@@ -1330,26 +2011,9 @@ typedef struct _ScreenPaintAttrib {
     GLfloat zCamera;
 } ScreenPaintAttrib;
 
-/* XXX: scale and translate fields will be removed */
-typedef struct _WindowPaintAttrib {
-    GLushort opacity;
-    GLushort brightness;
-    GLushort saturation;
-    GLfloat  xScale;
-    GLfloat  yScale;
-    GLfloat  xTranslate;
-    GLfloat  yTranslate;
-} WindowPaintAttrib;
-
 extern ScreenPaintAttrib defaultScreenPaintAttrib;
 extern WindowPaintAttrib defaultWindowPaintAttrib;
 
-typedef struct _CompMatrix {
-    float xx; float yx;
-    float xy; float yy;
-    float x0; float y0;
-} CompMatrix;
-
 #define COMP_TEX_COORD_X(m, vx) ((m)->xx * (vx) + (m)->x0)
 #define COMP_TEX_COORD_Y(m, vy) ((m)->yy * (vy) + (m)->y0)
 
@@ -1407,7 +2071,7 @@ typedef void (*DisableOutputClippingProc) (CompScreen *screen);
 typedef void (*WalkerFiniProc) (CompScreen *screen,
 				CompWalker *walker);
 
-typedef CompWindow *(*WalkInitProc) (CompScreen *screen);
+typedef CompWindow *(*WalkInitProc) (CompWindow *parent);
 typedef CompWindow *(*WalkStepProc) (CompWindow *window);
 
 struct _CompWalker {
@@ -1420,6 +2084,16 @@ struct _CompWalker {
     WalkStepProc prev;
 };
 
+typedef void (*PainterFiniProc) (CompScreen  *screen,
+				 CompPainter *painter);
+
+struct _CompPainter {
+    PainterFiniProc fini;
+    CompPrivate	    priv;
+
+    PaintWindowProc paintObject;
+};
+
 /*
   window paint flags
 
@@ -1450,6 +2124,12 @@ struct _CompWalker {
 #define PAINT_WINDOW_WITH_OFFSET_MASK           (1 << 2)
 
 /*
+  this flag is present when occlusion detection has been
+  performed and the window clip region is properly set.
+*/
+#define PAINT_WINDOW_CLIP_MASK                  (1 << 3)
+
+/*
   flag indicate that window is translucent.
 */
 #define PAINT_WINDOW_TRANSLUCENT_MASK           (1 << 16)
@@ -1470,12 +2150,11 @@ struct _CompWalker {
 */
 #define PAINT_WINDOW_BLEND_MASK			(1 << 19)
 
+/*
+  flag indicate that there might be transformed child windows.
+*/
+#define PAINT_WINDOW_WITH_TRANSFORMED_CHILD_MASK (1 << 20)
 
-typedef Bool (*PaintWindowProc) (CompWindow		 *window,
-				 const WindowPaintAttrib *attrib,
-				 const CompTransform     *transform,
-				 Region			 region,
-				 unsigned int		 mask);
 
 typedef Bool (*DrawWindowProc) (CompWindow	     *window,
 				const CompTransform  *transform,
@@ -1494,8 +2173,6 @@ typedef void (*DrawWindowTextureProc) (CompWindow	    *w,
 				       const FragmentAttrib *fragment,
 				       unsigned int	    mask);
 
-typedef void (*DrawWindowGeometryProc) (CompWindow *window);
-
 typedef void (*PaintCursorProc) (CompCursor	     *cursor,
 				 const CompTransform *transform,
 				 Region		     region,
@@ -1594,6 +2271,11 @@ paintWindow (CompWindow		     *w,
 	     unsigned int	     mask);
 
 void
+drawTransformedWindowWithChildren (CompWindow              *w,
+				   const WindowPaintAttrib *attrib,
+				   const CompTransform     *transform);
+
+void
 paintCursor (CompCursor		 *cursor,
 	     const CompTransform *transform,
 	     Region		 region,
@@ -1901,8 +2583,12 @@ typedef void (*WindowStateChangeNotifyProc) (CompWindow   *window,
 typedef void (*OutputChangeNotifyProc) (CompScreen *screen);
 
 typedef void (*InitWindowWalkerProc) (CompScreen *screen,
+				      CompWindow *parent,
 				      CompWalker *walker);
 
+typedef void (*InitObjectPainterProc) (CompScreen  *screen,
+				       CompPainter *painter);
+
 #define COMP_SCREEN_DAMAGE_PENDING_MASK (1 << 0)
 #define COMP_SCREEN_DAMAGE_REGION_MASK  (1 << 1)
 #define COMP_SCREEN_DAMAGE_ALL_MASK     (1 << 2)
@@ -1925,12 +2611,6 @@ typedef struct _CompGrab {
     const char *name;
 } CompGrab;
 
-typedef struct _CompGroup {
-    struct _CompGroup *next;
-    unsigned int      refCnt;
-    Window	      id;
-} CompGroup;
-
 typedef struct _CompStartupSequence {
     struct _CompStartupSequence *next;
     SnStartupSequence		*sequence;
@@ -2019,8 +2699,8 @@ struct _CompScreen {
 
     CompScreen  *next;
     CompDisplay *display;
-    CompWindow	*windows;
-    CompWindow	*reverseWindows;
+
+    CompWindow root;
 
     char *windowPrivateIndices;
     int  windowPrivateLen;
@@ -2038,7 +2718,6 @@ struct _CompScreen {
     REGION	      region;
     Region	      damage;
     unsigned long     damageMask;
-    Window	      root;
     Window	      overlay;
     Window	      output;
     XWindowAttributes attrib;
@@ -2061,7 +2740,6 @@ struct _CompScreen {
     CompTexture       backgroundTexture;
     Bool	      backgroundLoaded;
     unsigned int      pendingDestroys;
-    int		      desktopWindowCount;
     unsigned int      mapNum;
     unsigned int      activeNum;
 
@@ -2071,9 +2749,6 @@ struct _CompScreen {
     CompOutput fullscreenOutput;
     Bool       hasOverlappingOutputs;
 
-    int windowOffsetX;
-    int windowOffsetY;
-
     XRectangle lastViewport;
 
     CompActiveWindowHistory history[ACTIVE_WINDOW_HISTORY_NUM];
@@ -2220,7 +2895,8 @@ struct _CompScreen {
 
     OutputChangeNotifyProc outputChangeNotify;
 
-    InitWindowWalkerProc initWindowWalker;
+    InitWindowWalkerProc  initWindowWalker;
+    InitObjectPainterProc initObjectPainter;
 };
 
 #define GET_CORE_SCREEN(object) ((CompScreen *) (object))
@@ -2283,6 +2959,12 @@ void
 detectRefreshRateOfScreen (CompScreen *s);
 
 void
+getSupportingWmCheck (CompWindow *w);
+
+void
+getDesktopHints (CompScreen *s);
+
+void
 showOutputWindow (CompScreen *s);
 
 void
@@ -2312,15 +2994,6 @@ void
 damagePendingOnScreen (CompScreen *s);
 
 void
-insertWindowIntoScreen (CompScreen *s,
-			CompWindow *w,
-			Window	   aboveId);
-
-void
-unhookWindowFromScreen (CompScreen *s,
-			CompWindow *w);
-
-void
 forEachWindowOnScreen (CompScreen	 *screen,
 		       ForEachWindowProc proc,
 		       void		 *closure);
@@ -2330,6 +3003,10 @@ findWindowAtScreen (CompScreen *s,
 		    Window     id);
 
 CompWindow *
+findClientWindowAtScreen (CompScreen *s,
+			  Window      id);
+
+CompWindow *
 findTopLevelWindowAtScreen (CompScreen *s,
 			    Window      id);
 
@@ -2436,7 +3113,7 @@ disableScreenEdge (CompScreen *s,
 		   int	      edge);
 
 Window
-getTopWindow (CompScreen *s);
+getTopWindow (CompWindow *parent);
 
 void
 makeScreenCurrent (CompScreen *s);
